# BrowserApi

All URIs are relative to *https://api.browshot.com/api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**browserInfoGet**](BrowserApi.md#browserInfoGet) | **GET** /browser/info | Get information about a browser
[**browserListGet**](BrowserApi.md#browserListGet) | **GET** /browser/list | Get all browsers


<a name="browserInfoGet"></a>
# **browserInfoGet**
> Browser browserInfoGet(id)

Get information about a browser

Get information about a browser.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.BrowserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: apiKeyQuery
ApiKeyAuth apiKeyQuery = (ApiKeyAuth) defaultClient.getAuthentication("apiKeyQuery");
apiKeyQuery.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//apiKeyQuery.setApiKeyPrefix("Token");

BrowserApi apiInstance = new BrowserApi();
Integer id = 56; // Integer | browser ID
try {
    Browser result = apiInstance.browserInfoGet(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling BrowserApi#browserInfoGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **Integer**| browser ID |

### Return type

[**Browser**](Browser.md)

### Authorization

[apiKeyQuery](../README.md#apiKeyQuery)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="browserListGet"></a>
# **browserListGet**
> BrowserList browserListGet()

Get all browsers

Get all browsers.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.BrowserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: apiKeyQuery
ApiKeyAuth apiKeyQuery = (ApiKeyAuth) defaultClient.getAuthentication("apiKeyQuery");
apiKeyQuery.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//apiKeyQuery.setApiKeyPrefix("Token");

BrowserApi apiInstance = new BrowserApi();
try {
    BrowserList result = apiInstance.browserListGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling BrowserApi#browserListGet");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**BrowserList**](BrowserList.md)

### Authorization

[apiKeyQuery](../README.md#apiKeyQuery)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

